<?php

namespace Faker\Philippines;

use Faker\Extension\Extension;

class PhoneNumber extends \Faker\Provider\PhoneNumber implements Extension
{
    protected static $formats = [
        '{{landlinePhoneNumber}}',
        '{{mobilePhoneNumber}}',
    ];

    /**
     * @see https://github.com/google/libphonenumber/blob/v8.13.28/resources/metadata/63/ranges.csv
     */
    protected static $landlineFormats = [
        '2 #####',
        '2 3### ####',
        '2 4### ####',
        '2 5### ####',
        '2 6### ####',
        '2 7### ####',
        '2 8### ####',
        '32 ### ####',
        '34 ### ####',
        '35 ### ####',
        '36 ### ####',
        '38 ### ####',
        '34 ### ####',
        '42 ### ####',
        '43 ### ####',
        '44 ### ####',
        '45 ### ####',
        '46 ### ####',
        '47 ### ####',
        '48 ### ####',
        '49 ### ####',
        '43 ### ####',
        '52 ### ####',
        '53 ### ####',
        '54 ### ####',
        '55 ### ####',
        '56 ### ####',
        '62 ### ####',
        '63 ### ####',
        '64 ### ####',
        '65 ### ####',
        '68 ### ####',
        '72 ### ####',
        '74 ### ####',
        '75 ### ####',
        '77 ### ####',
        '78 ### ####',
        '82 ### ####',
        '83 ### ####',
        '84 ### ####',
        '85 ### ####',
        '86 ### ####',
        '87 ### ####',
        '88 0## ####',
        '88 1## ####',
        '88 3## ####',
        '88 4## ####',
        '88 5## ####',
        '88 6## ####',
        '88 7## ####',
        '88 8## ####',
        '88 9## ####',
        '88 21# ####',
        '88 23# ####',
        '88 24# ####',
        '88 25# ####',
        '88 26# ####',
        '88 27# ####',
        '88 28# ####',
        '88 29# ####',
        '88 20# ####',
        '8822 ######',
        '+63 2 #####',
        '+63 2 3### ####',
        '+63 2 4### ####',
        '+63 2 5### ####',
        '+63 2 6### ####',
        '+63 2 7### ####',
        '+63 2 8### ####',
        '+63 32 ### ####',
        '+63 34 ### ####',
        '+63 35 ### ####',
        '+63 36 ### ####',
        '+63 38 ### ####',
        '+63 34 ### ####',
        '+63 42 ### ####',
        '+63 43 ### ####',
        '+63 44 ### ####',
        '+63 45 ### ####',
        '+63 46 ### ####',
        '+63 47 ### ####',
        '+63 48 ### ####',
        '+63 49 ### ####',
        '+63 43 ### ####',
        '+63 52 ### ####',
        '+63 53 ### ####',
        '+63 54 ### ####',
        '+63 55 ### ####',
        '+63 56 ### ####',
        '+63 62 ### ####',
        '+63 63 ### ####',
        '+63 64 ### ####',
        '+63 65 ### ####',
        '+63 68 ### ####',
        '+63 72 ### ####',
        '+63 74 ### ####',
        '+63 75 ### ####',
        '+63 77 ### ####',
        '+63 78 ### ####',
        '+63 82 ### ####',
        '+63 83 ### ####',
        '+63 84 ### ####',
        '+63 85 ### ####',
        '+63 86 ### ####',
        '+63 87 ### ####',
        '+63 88 0## ####',
        '+63 88 1## ####',
        '+63 88 3## ####',
        '+63 88 4## ####',
        '+63 88 5## ####',
        '+63 88 6## ####',
        '+63 88 7## ####',
        '+63 88 8## ####',
        '+63 88 9## ####',
        '+63 88 21# ####',
        '+63 88 23# ####',
        '+63 88 24# ####',
        '+63 88 25# ####',
        '+63 88 26# ####',
        '+63 88 27# ####',
        '+63 88 28# ####',
        '+63 88 29# ####',
        '+63 88 20# ####',
        '+63 8822 ######',
    ];

    /**
     * @see https://github.com/google/libphonenumber/blob/v8.13.28/resources/metadata/63/ranges.csv
     */
    protected static $mobileFormats = [
        '813 ### ####',
        '817 ### ####',
        '895 ### ####',
        '896 ### ####',
        '897 ### ####',
        '898 ### ####',
        '905 ### ####',
        '906 ### ####',
        '907 ### ####',
        '908 ### ####',
        '909 ### ####',
        '910 ### ####',
        '911 ### ####',
        '912 ### ####',
        '918 ### ####',
        '919 ### ####',
        '914 ### ####',
        '915 ### ####',
        '916 ### ####',
        '917 ### ####',
        '920 ### ####',
        '921 ### ####',
        '922 ### ####',
        '923 ### ####',
        '925 ### ####',
        '928 ### ####',
        '929 ### ####',
        '924 ### ####',
        '944 ### ####',
        '926 ### ####',
        '927 ### ####',
        '930 ### ####',
        '931 ### ####',
        '932 ### ####',
        '933 ### ####',
        '938 ### ####',
        '939 ### ####',
        '934 ### ####',
        '994 ### ####',
        '935 ### ####',
        '936 ### ####',
        '937 ### ####',
        '965 ### ####',
        '966 ### ####',
        '967 ### ####',
        '995 ### ####',
        '996 ### ####',
        '997 ### ####',
        '942 ### ####',
        '943 ### ####',
        '946 ### ####',
        '947 ### ####',
        '948 ### ####',
        '949 ### ####',
        '945 ### ####',
        '95# ### ####',
        '960 ### ####',
        '961 ### ####',
        '962 ### ####',
        '963 ### ####',
        '964 ### ####',
        '968 ### ####',
        '969 ### ####',
        '97# ### ####',
        '981 ### ####',
        '985 ### ####',
        '988 ### ####',
        '983 ### ####',
        '986 ### ####',
        '987 ### ####',
        '989 ### ####',
        '991 ### ####',
        '992 ### ####',
        '993 ### ####',
        '998 ### ####',
        '999 ### ####',
        '+63 813 ### ####',
        '+63 817 ### ####',
        '+63 895 ### ####',
        '+63 896 ### ####',
        '+63 897 ### ####',
        '+63 898 ### ####',
        '+63 905 ### ####',
        '+63 906 ### ####',
        '+63 907 ### ####',
        '+63 908 ### ####',
        '+63 909 ### ####',
        '+63 910 ### ####',
        '+63 911 ### ####',
        '+63 912 ### ####',
        '+63 918 ### ####',
        '+63 919 ### ####',
        '+63 914 ### ####',
        '+63 915 ### ####',
        '+63 916 ### ####',
        '+63 917 ### ####',
        '+63 920 ### ####',
        '+63 921 ### ####',
        '+63 922 ### ####',
        '+63 923 ### ####',
        '+63 925 ### ####',
        '+63 928 ### ####',
        '+63 929 ### ####',
        '+63 924 ### ####',
        '+63 944 ### ####',
        '+63 926 ### ####',
        '+63 927 ### ####',
        '+63 930 ### ####',
        '+63 931 ### ####',
        '+63 932 ### ####',
        '+63 933 ### ####',
        '+63 938 ### ####',
        '+63 939 ### ####',
        '+63 934 ### ####',
        '+63 994 ### ####',
        '+63 935 ### ####',
        '+63 936 ### ####',
        '+63 937 ### ####',
        '+63 965 ### ####',
        '+63 966 ### ####',
        '+63 967 ### ####',
        '+63 995 ### ####',
        '+63 996 ### ####',
        '+63 997 ### ####',
        '+63 942 ### ####',
        '+63 943 ### ####',
        '+63 946 ### ####',
        '+63 947 ### ####',
        '+63 948 ### ####',
        '+63 949 ### ####',
        '+63 945 ### ####',
        '+63 95# ### ####',
        '+63 960 ### ####',
        '+63 961 ### ####',
        '+63 962 ### ####',
        '+63 963 ### ####',
        '+63 964 ### ####',
        '+63 968 ### ####',
        '+63 969 ### ####',
        '+63 97# ### ####',
        '+63 981 ### ####',
        '+63 985 ### ####',
        '+63 988 ### ####',
        '+63 983 ### ####',
        '+63 986 ### ####',
        '+63 987 ### ####',
        '+63 989 ### ####',
        '+63 991 ### ####',
        '+63 992 ### ####',
        '+63 993 ### ####',
        '+63 998 ### ####',
        '+63 999 ### ####',
    ];

    /**
     * @see https://github.com/google/libphonenumber/blob/v8.13.28/resources/metadata/63/ranges.csv
     */
    protected static $tollFreeFormats = [
        '1800 #### ###',
        '1800 #### ####',
        '1800 #### #####',
        '+63 1800 #### ###',
        '+63 1800 #### ####',
        '+63 1800 #### #####',
    ];

    /**
     * @example '53 123 4567'
     *
     * @return string
     */
    public function landlinePhoneNumber()
    {
        return static::numerify($this->generator->parse(static::randomElement(static::$landlineFormats)));
    }

    /**
     * @example '+63 991 123 4567'
     *
     * @return string
     */
    public function mobilePhoneNumber()
    {
        return static::numerify($this->generator->parse(static::randomElement(static::$mobileFormats)));
    }

    /**
     * @example '1800 1234 56789'
     *
     * @return string
     */
    public function tollFreePhoneNumber()
    {
        return static::numerify($this->generator->parse(static::randomElement(static::$tollFreeFormats)));
    }
}
